
package com.ibm.abbot.tester.swt;

import org.eclipse.swt.graphics.*;
import org.eclipse.swt.widgets.*;

/**
 * Provides widget-specific actions, assertions, and getter methods for
 * widgets of type Button.
 */
public class ButtonTester extends ControlTester {
	/* Widget properties that are obtainable by member getter functions */
	int alignment;
	Image image;
	boolean selection;
	String text;
	
	/**
	 * Sets the above properties to their current values for the given widget. 
	 * NOTE: This should be called in a block of code synchronized on this
	 * tester.
	 */	
	protected synchronized void getProperties(final Button b){
		super.getProperties(b);	
		Robot.syncExec(b.getDisplay(),this,new Runnable(){
			public void run(){
				alignment = b.getAlignment();
				image = b.getImage();
				selection = b.getSelection();
				text = b.getText();			
			}			
		});
	}

	/**
	 * These getter methods return a particular property of the given widget.
	 * @see the corresponding member function in class Widget   
	 */ 	
	/* Begin getters */
	public synchronized int getAlignment(Button b) {
		getProperties(b);
		return alignment;
	}

	public synchronized Image getImage(Button b) {
		getProperties(b);
		return image;
	}

	public synchronized boolean getSelection(Button b) {
		getProperties(b);
		return selection;
	}

	public synchronized String getText(Button b) {
		getProperties(b);
		return text;
	}
	/* End getters */
}
