
package com.ibm.abbot.tester.swt;

import org.eclipse.swt.widgets.*;

/**
 * Provides widget-specific actions, assertions, and getter methods for
 * widgets of type Canvas.
 */
public class CanvasTester extends CompositeTester {
	/* Widget properties that are obtainable by member getter functions */
	protected Caret caret;
	
	/**
	 * Sets the above properties to their current values for the given widget. 
	 * NOTE: This should be called in a block of code synchronized on this
	 * tester.
	 */	
	protected synchronized void getProperties(final Canvas c){
		super.getProperties(c);
		Robot.syncExec(c.getDisplay(),this,new Runnable(){
			public void run(){
				caret = c.getCaret();
			}
		});
	}
	
	/**
	 * These getter methods return a particular property of the given widget.
	 * @see the corresponding member function in class Widget   
	 */ 
	/* Begin getters */
	public synchronized Caret getCaret(Canvas c){
		getProperties(c);
		return caret;		
	}
	/* End getters */
}
