
package com.ibm.abbot.tester.swt;

import org.eclipse.swt.widgets.Item;
import org.eclipse.swt.graphics.Image;

public class ItemTester extends WidgetTester{
	/** properties **/
	protected Image image;
	protected String text;
		
	/**
	 * Sets the above properties to their current values for the given widget. 
	 * NOTE: This should be called in a block of code synchronized on this
	 * tester.
	 */	
	protected synchronized void getProperties(final Item item){
		super.getProperties(item);
		Robot.syncExec(item.getDisplay(),this,new Runnable(){
			public void run(){
				image = item.getImage();
				text = item.getText();
			}
		});
	}

	/**
	 * These getter methods return a particular property of the given widget.
	 * @see the corresponding member function in class Widget   
	 */ 
	/* Begin getters */
	public synchronized Image getImage(final Item item){
		getProperties(item);
		return image;
	}
	public synchronized String getText(final Item item){
		getProperties(item);
		return text;
	}
	/* End getters */
}
