
package com.ibm.abbot.tester.swt;

import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;

public class MenuItemTester extends ItemTester {
	/** properties **/
	protected int accelerator;
	protected boolean enabled,selection;
	protected Menu menu, parent;
	
	/**
	 * Sets the above properties to their current values for the given widget. 
	 * NOTE: This should be called in a block of code synchronized on this
	 * tester.
	 */	
	protected synchronized void getProperties(final MenuItem item){
		super.getProperties(item);
		Robot.syncExec(item.getDisplay(),this,new Runnable(){
			public void run(){
				accelerator = item.getAccelerator();
				enabled = item.getEnabled();
				selection = item.getSelection();
				menu = item.getMenu();
				parent = item.getParent();
			}
		});
	}

	/**
	 * These getter methods return a particular property of the given widget.
	 * @see the corresponding member function in class Widget   
	 */ 
	/* Begin getters */
	public synchronized int getAccelerator(MenuItem item){
		getProperties(item);
		return accelerator;
	}
	public synchronized boolean getEnabled(MenuItem item){
		getProperties(item);
		return enabled;
	}
	public synchronized boolean getSelection(MenuItem item){
		getProperties(item);
		return selection;
	}
	public synchronized Menu getMenu(MenuItem item){
		getProperties(item);
		return menu;
	}
	public synchronized Menu getParent(MenuItem item){
		getProperties(item);
		return parent;
	}
	/* end getters */
}
