package com.ibm.abbot;

import junit.framework.Test;
import junit.framework.TestSuite;

import com.ibm.abbot.tester.swt.*;
import com.ibm.abbot.examples.CelsiusConverterTest;

public class AllTests {

	public static Test suite() {
		TestSuite suite = new TestSuite("Test for com.ibm.abbot and com.ibm.abbot.tester.swt");
		
		/* For some reason, when WidgetRecorderTest, or others like it,
		 * precede tests that sub-class WidgetTestFixture, the shells 
		 * that are opened in WidgetTestFixture are opened as minimized,
		 * and do not respond to shell.setMinimized(false).  Hence, they
		 * don't receive mouse/keyboard input and the tests fail.  Until
		 * this is fixed, follow the directions below for placing
		 * new unit tests. 
		 */		
		
		// PUT ALL TESTS THAT SUB-CLASS WIDGETTESTFIXTURE HERE:
		suite.addTestSuite(ListTesterTest.class);
		//$JUnit-BEGIN$
		suite.addTestSuite(DefaultWidgetFinderTest.class);
		//$JUnit-END$
		suite.addTestSuite(ComboTesterTest.class);
		suite.addTestSuite(RobotTest.class);
		suite.addTestSuite(TextTesterTest.class);
		suite.addTestSuite(WidgetLocatorTest.class);
		suite.addTestSuite(WidgetTesterTest.class);
		suite.addTestSuite(SashTesterTest.class);
		// --------------------------------------------------
		
		// NOW, PUT OTHERS THAT FOLLOW THE SAME PATTERN OF SETUP AS
		// CELSIUSCONVERTERTEST HERE:
		//suite.addTestSuite(WidgetRecorderTest.class);
		suite.addTestSuite(CelsiusConverterTest.class);
		suite.addTestSuite(TableTesterTest.class);
		return suite;
	}
}
