
package com.ibm.abbot.examples;

import org.eclipse.swt.widgets.*;
import org.eclipse.swt.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.internal.win32.*;

import com.ibm.abbot.tester.swt.WidgetTester;

import java.util.*;

public class TableSample {
	public Shell shell;
	public Table table;
	public static Text text;
	public int numItems = 6;
	public TableColumn[] cols = new TableColumn[4];
	public TableItem[] items= new TableItem[numItems];
	public String[] colTitles = {	"Name",		"ID",	"Department",			"Age"};
	public String[][] itemTexts = {{"Kevin",	"0",	"Accounting",			"22"},
								   {"Stephen",	"1",	"Manufacturing",		"20"},
								   {"Will",		"2",	"Accounting",			"21"},
								   {"Jim",		"3",	"Human Resources",		"22"},
								   {"Sarah",	"4",	"General Management",	"20"},
								   {"Anna",		"5",	"Manufacturing",		"30"}};
	
	public TableSample(Display display){
		Image logo = new Image(display,"logo32.gif");
		shell = new Shell(display, SWT.SHELL_TRIM);
		shell.setText("Table Sample");
		shell.setImage(logo);
		table = new Table(shell,SWT.MULTI|SWT.CHECK);
		table.setHeaderVisible(true);
			
		for(int i=0; i<cols.length;i++){
			cols[i] = new TableColumn(table,SWT.CENTER);
			cols[i].setText(colTitles[i]);
		}
		for(int i=0; i<numItems;i++){
			items[i] = new TableItem(table,SWT.NONE);
			items[i].setText(itemTexts[i%(itemTexts.length)]);
		}
		for(int i=0; i<cols.length;i++){
			cols[i].pack();
			//cols[i].setWidth(200);
		}
				
		table.pack();
		table.setLocation(0,0);

		// setup popup
		Menu popup = new Menu(table);
		table.setMenu(popup);
		MenuItem item0 = new MenuItem(popup,SWT.CASCADE);
		item0.setText("Item 0");
		MenuItem item1 = new MenuItem(popup,SWT.NONE);
		item1.setText("Item 1");
		Menu cascade0 = new Menu(shell,SWT.DROP_DOWN);
		item0.setMenu(cascade0);
		MenuItem item2 = new MenuItem(cascade0,SWT.NONE);
		item2.setText("Item 2");
		MenuItem item3 = new MenuItem(cascade0,SWT.NONE);
		item3.setText("Item 3");
						
		// setup bar menu
		Menu bar = new Menu(shell,SWT.BAR);
		shell.setMenuBar(bar);
		MenuItem barItem0 = new MenuItem(bar,SWT.CASCADE);
		barItem0.setText("Bar MenuItem 0");
		Menu cascade1 = new Menu(shell,SWT.DROP_DOWN);
		barItem0.setMenu(cascade1);
		MenuItem item4 = new MenuItem(cascade1,SWT.NONE);
		item4.setText("Item 4");
		
		
		final Shell window = new Shell(shell,SWT.BORDER);
		window.setSize(100,100);
		
		item4.addListener(SWT.Selection,new Listener(){
			public void handleEvent(Event e){
				window.open();
			}
		});
		
		
		// add a text widget
		Text text = new Text(shell,SWT.WRAP);
		text.setLocation(0,table.getLocation().y+table.getBounds().height);
		text.setSize(table.getBounds().width,table.getBounds().height);
		
		shell.pack();
		shell.open();	
		
		
	}
	
	public static String toString(MSG msg){
		String res = "<";
		res+="hwnd="+msg.hwnd;
		res+=" lParam="+msg.lParam;
		res+=" message="+msg.message;
		res+=" time="+msg.time;
		res+=" wParam="+msg.wParam;
		res+=" location=("+msg.x+","+msg.y+")>";
		
		return res;
	}
	
	//Display display0;
	static MSG msg;
	static boolean finished =false;
	public static void main(String[] argv){
//		
//		Thread t = new Thread(){
//			public void run(){
//				String msgString,oldString="";
//				while(display0==null);
//				while(!finished){
//					msg = display0.msg;
//					if(msg!=null){
//						msgString = TableSample.toString(msg);									
//						if(!msgString.equals(oldString)){
//							oldString=msgString;
//							System.out.println(msgString);
//						}
//					}
//				}
//			}
//		};
//		t.start();
		
		//Display display0 = new Display();
		Display display0 = Display.getDefault();
//		// all types of events an SWT widget can respond to
//		int[] eventTypes ={	SWT.None,		SWT.KeyDown, 		SWT.KeyUp,
//							SWT.MouseDown,	SWT.MouseUp,		SWT.MouseMove,
//							SWT.MouseEnter,	SWT.MouseExit,		SWT.MouseDoubleClick,
//							SWT.Paint,		SWT.Move,			SWT.Resize,
//							SWT.Dispose,	SWT.Selection,		SWT.DefaultSelection,
//							SWT.FocusIn,	SWT.FocusOut,		SWT.Expand,
//							SWT.Collapse,	SWT.Iconify,		SWT.Deiconify,
//							SWT.Close,		SWT.Show,			SWT.Hide,
//							SWT.Modify,		SWT.Verify,			SWT.Activate,
//							SWT.Deactivate,	SWT.Help,			SWT.DragDetect,
//							SWT.Arm,		SWT.Traverse,		SWT.MouseHover,
//							SWT.HardKeyDown,SWT.HardKeyUp,		SWT.MenuDetect };
	
		Listener recorder = new Listener(){
			public void handleEvent(org.eclipse.swt.widgets.Event e){
				if(isSignificant(e))
					System.out.println(getEventName(e)+
										" accel="+getAccelerator(e)+
										//" button="+e.button+
										//" count="+e.count+
										//" detail="+e.detail+
										//" end="+e.end+
										//" data="+e.data+
										" char="+e.character+
										" keycode="+e.keyCode+	
										" stateMask="+e.stateMask+								
										" doit="+e.doit+
										//" display="+e.display+
										//" gc="+e.gc+
										//" item="+e.item+									
										" height="+e.height+
										" start="+e.start+
										" text="+e.text+
										//" time="+e.time+
										//" type="+e.type+
										" width="+e.width+
										" location=("+e.x+","+e.y+")"+
										" widget="+e.widget);
			}
		};		
			
		TableSample ts = new TableSample(display0);
		
		//System.out.println(SWT.CONTROL|(int)'m');
		WidgetTester tester = new WidgetTester();
//		tester.actionKeyPress(SWT.CONTROL);
//		//tester.actionKeyPress('m');
//		tester.actionWaitForIdle(display0);
//		//System.out.println("The above event is the one we're shooting for");
//		//tester.actionKeyRelease('m');
//		tester.actionKeyRelease(SWT.CONTROL);		
//		tester.actionWaitForIdle(display0);
//		
//		tester.actionKey(17039360);
//		tester.actionWaitForIdle(display0);

		//tester.actionKey(SWT.CONTROL|'f',display0);
		
				
		while(!ts.shell.isDisposed()){
			if(!display0.readAndDispatch())
				display0.sleep();			
		}		
	}
	
	/** filters out events **/
	public static boolean isSignificant(Event e){
		return true;
		
//		return (e.type==SWT.KeyDown ||
//				e.type==SWT.KeyUp);
	}
	
	public static String[] eventNames = {	"None",			"KeyDown", 		"KeyUp",
											"MouseDown",	"MouseUp",		"MouseMove",
											"MouseEnter",	"MouseExit",	"MouseDoubleClick",
											"Paint",		"Move",			"Resize",
											"Dispose",		"Selection",	"DefaultSelection",
											"FocusIn",		"FocusOut",		"Expand",
											"Collapse",		"Iconify",		"Deiconify",
											"Close",		"Show",			"Hide",
											"Modify",		"Verify",		"Activate",
											"Deactivate",	"Help",			"DragDetect",
											"Arm",			"Traverse",		"MouseHover",
											"HardKeyDown",	"HardKeyUp",	"MenuDetect" };	
	
	public static String getEventName(Event e){
		String res= eventNames[e.type];
		final int NAME_LENGTH = 12;
		for(int i=eventNames[e.type].length(); i<NAME_LENGTH;i++){
			res+=" ";
		}
		return res;
	}
	
	protected static int getAccelerator(Event e){
		int accel = 0;
		
		if(e.keyCode!=0){
			accel |= SWT.KEYCODE_BIT;
			accel |= e.keyCode;	
			accel |= e.stateMask;
		}		
		else	
			accel |= e.character;
				
		return accel;
	}
	
	public static LinkedList eventList = new LinkedList();
	public static final int MAX_COUNT = 10;
	public static synchronized String getEventList(Event newEvent){
		if(eventList.size()<MAX_COUNT){
			eventList.add(new String(newEvent+" Time="+newEvent.time));
		}
		else{
			eventList.remove(0);
			eventList.add(new String(newEvent+" Time="+newEvent.time));
		}
		
		String res = "";
		for (int i=0; i<eventList.size();i++){
			res+=(String)(eventList.get(i));
		}
		return res;
	}
}
