package com.ibm.abbot.tester.swt;

import org.eclipse.swt.widgets.*;
import org.eclipse.swt.layout.*;

import org.eclipse.swt.*;

import junit.framework.TestCase;

/**
 * A wrapper class for testing SWT Widgets with JUnit.  
 */
public class WidgetTestFixture extends TestCase {
	
	protected int delay = 100;
	protected static final int DISPLAY_TIMEOUT = 1000000; //ms
	protected Robot robot = new Robot();
	//protected static Display display = robot.getDisplay();////
	//protected Display display = Display.getDefault();
	//private Shell shell;
	protected static Thread currentThread;
	protected static final int DEFAULT_SHELL_STYLE = SWT.SHELL_TRIM;
	protected static final int DEFAULT_SHELL_LAYOUT = SWT.HORIZONTAL;
	protected static final int DEFAULT_SHELL_WIDTH = 200;
	protected static final int DEFAULT_SHELL_HEIGHT = 200;
	protected static final int DEFAULT_SHELL_X = 20;
	protected static final int DEFAULT_SHELL_Y = 20;
	protected final RowLayout DEFAULT_LAYOUT = new RowLayout(SWT.HORIZONTAL);
	protected Thread displayThread;

	public WidgetTestFixture() {
		super(null);
	}

	/** Construct a test case with the given name.  */
	public WidgetTestFixture(String name) {
		super(name);
		
	}
	
	/*
	public void setUp(){
		//display = Display.getDefault();
	}
	
	

	public void tearDown(){
	}
	*/
				
	/** Return an Abbot robot for basic event generation.  */
	protected Robot getRobot() { return robot; }
/*
	protected static class ShellFactory{
		static Hashtable ht = new Hashtable();
		/** Creates a shell associated with the calling thread */ 
/*
		public static synchronized Shell createShell(){
			if(display==null)			
				System.out.println("NULL DISPLAY");
			display.syncExec(new Runnable(){
				public void run(){
					shell = new Shell(Display.getCurrent(),DEFAULT_SHELL_STYLE);
					shell.setLayout(new RowLayout(DEFAULT_SHELL_LAYOUT));	
				}
			});						
			currentThread = Thread.currentThread();
			ht.put(currentThread,shell);			
			return shell;
		}
		/** Gets the last shell created by the calling thread and 
		 *  associates it with the given widget; returns
		 *  null if there is no shell associated with this thread.
		 */ 
		 /*
		public static Shell getLastCreated(){
			Thread current = Thread.currentThread();
			Shell shell = (Shell)(ht.get(current));
			return shell;	
		}	
	}// end class ShellFactory

	protected Shell showShell(Widget w){
		return showShell(w, null);
	}
*/
	/** Places the given Control inside a shell of a given size,
	 *  and opens the shell.
	 * 
	 *  To be used as (example): <code>
	 *  Button button = new Button(ShellFactory.createShell(),SWT.PUSH);
	 *  Shell shell= showShell(button);
	 *  </code>
	 * 
	 *  NOTE: cleanup is required, as <code>shell.dispose();</code>.
	 * 
	 **/
	/*
	protected Shell showShell(Widget w, Point size){
		Shell shell = ShellFactory.getLastCreated();
		if(size!=null) shell.setSize(size);
		else shell.setSize(DEFAULT_SHELL_WIDTH,DEFAULT_SHELL_HEIGHT);
		shell.setLocation(DEFAULT_SHELL_X,DEFAULT_SHELL_Y);
		shell.setLayout(DEFAULT_LAYOUT);
		shell.setText(getName());
		shell.open();				
		return shell;		
	}
	protected Shell showShell(Shell shell, Point size){
		if(size!=null) shell.setSize(size);
		else shell.setSize(DEFAULT_SHELL_WIDTH,DEFAULT_SHELL_HEIGHT);
		shell.setLocation(DEFAULT_SHELL_X,DEFAULT_SHELL_Y);
		shell.setText(getName());
		shell.setLayout(DEFAULT_LAYOUT);
		shell.open();				
		return shell;		
	}
	*/
	protected void showShell(Shell shell){
		shell.open();
		shell.setMinimized(false);
		robot.focus(shell);
	//	robot.waitForIdle();
		Robot.delay(delay);
	}

	protected Shell createShell(){
		Display display = (Display.getCurrent()==null)?
						 	new Display():Display.getCurrent();
		//Display display = new Display();
		Shell shell = new Shell(display,SWT.SHELL_TRIM);
		shell.setSize(DEFAULT_SHELL_WIDTH,DEFAULT_SHELL_HEIGHT);
		shell.setLocation(DEFAULT_SHELL_X,DEFAULT_SHELL_Y);
		shell.setLayout(DEFAULT_LAYOUT);
		shell.setText(getName());
		return shell;
	}
	
	protected void hideShell(Shell shell){
		if(!shell.isDisposed()){
			shell.close();
			//shell.dispose();
			shell.getDisplay().dispose();
		}
		
	}	
	public void setDelay(int delay){
		this.delay = delay;
	}
	public int getDelay(){
		return delay;
	}
}
